local Interrupt_EventFrame = CreateFrame("frame")
Interrupt_EventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

local pciscript = CreateFrame("Frame")
pciscript:RegisterEvent("PLAYER_ENTERING_WORLD")
pciscript:RegisterEvent("ADDON_LOADED")
pciscript:RegisterEvent("PLAYER_LOGIN")
pciscript:RegisterEvent("PLAYER_LOGOUT")

local inInstance, instanceType = IsInInstance()

Interrupt_EventFrame:SetScript("OnEvent", function(self, event, ...)
        self[event](self, ...)
end)

function Interrupt_EventFrame:COMBAT_LOG_EVENT_UNFILTERED()
    local _, eventType, _, sourceGUID, sourceName, _, _, _, destName, _, _, sourceID, _, _, spellID, spellName, spellSchool = CombatLogGetCurrentEventInfo()
    -- Player interrupt
	if (TyllusInterrupt == 1 or TyllusInterrupt == nil) and eventType ==  "SPELL_INTERRUPT" and (IsInInstance(true,"party") or IsInInstance(true,"raid") or IsInInstance(true,"arena"))
	and (sourceGUID == UnitGUID("player") or sourceGUID == UnitGUID("pet")) then
        if TyllusInterruptSpellName == 1 then SendChatMessage(sourceName..' interrupted ' .. GetSpellLink(spellID)) else SendChatMessage(sourceName..' interrupted') end
    elseif eventType == "SPELL_INTERRUPT" and (sourceGUID == UnitGUID("player") or sourceGUID == UnitGUID("pet")) then
        if TyllusInterruptSpellName == 1 then print(sourceName..' interrupted ' .. GetSpellLink(spellID)) else print(sourceName..' interrupted') end
    end
	-- Others interrupt
	if (TyllusInterruptOthers == 1 or TyllusInterruptOthers == nil) and eventType ==  "SPELL_INTERRUPT" and (IsInInstance(true,"party") or IsInInstance(true,"raid") or IsInInstance(true,"arena"))
		and not (sourceGUID == UnitGUID("player") or sourceGUID == UnitGUID("pet")) and not UnitIsFriend("player", sourceGUID) then
	local localizedClass, englishClass, classIndex = UnitClass(sourceName);
		if localizedClass == nil then print("<|cfcc3300fTyllusInterrupt|r> " .. sourceName .. " interrupted " .. GetSpellLink(spellID))
		else
		print("<|cfcc3300fTyllusInterrupt|r> " .. sourceName .. " (" .. localizedClass .. ")" .. " interrupted " .. GetSpellLink(spellID))
		end
	end
end
----------
--Slash commands
----------
SLASH_TINT1 = "/tint";
local function handler(msg, editbox)
	if msg == 'say' then -- say
		if TyllusInterrupt == 0 then TyllusInterrupt = 1
		print ('|cfcc3300fTyllusInterrupt|r: Announcing interrupts to SAY channel has been turned |cf00cc00fON|r');
		else TyllusInterrupt = 0
		    print ('|cfcc3300fTyllusInterrupt|r: Announcing interrupts to SAY channel has been turned |cfcc3300fOFF|r');
		end
    elseif msg == 'status' then -- Status
		print ("|cfcc3300fTyllusInterrupt|r |cf0ffff00Status:|r");
    	if TyllusInterrupt == 0 then -- SAY turned on?
		local IsSayOn = "|cfcc3300fOFF|r" print ("Interrupt announce to SAY is " .. IsSayOn);
		else local IsSayOn = "|cf00cc00fON|r" print ("Interrupt announce to SAY is " .. IsSayOn);
      	end
      	if TyllusInterruptSpellName == 1 then -- Spell Name turned on?
		local SpellNameOn = "|cf00cc00fON|r"; print ("Announcing name of the interrupted spell is " .. SpellNameOn);
    	else local SpellNameOn = "|cfcc3300fOFF|r"; print ("Announcing name of the interrupted spell is " .. SpellNameOn);
      	end
		if TyllusInterruptOthers == 0 then -- Others' interrupt reported?
		local IsOthersOn = "|cfcc3300fOFF|r"; print ("Others' interrupt report to self is " .. IsOthersOn);
    	else local IsOthersOn = "|cf00cc00fON|r"; print ("Others' interrupt report to self is " .. IsOthersOn);
      	end
    elseif msg == 'name' then -- Name
		if TyllusInterruptSpellName == 1 then TyllusInterruptSpellName = 0
		print ('|cfcc3300fTyllusInterrupt|r: Announcing name of the interrupted spell is |cfcc3300fOFF|r');
		else TyllusInterruptSpellName = 1
		    print ('|cfcc3300fTyllusInterrupt|r: Announcing name of the interrupted spell is |cf00cc00fON|r');
		end
	    elseif msg == 'others' then -- Others
		if TyllusInterruptOthers == 1 then TyllusInterruptOthers = 0
		print ("|cfcc3300fTyllusInterrupt|r: Self report for Others' interrupt is |cfcc3300fOFF|r");
		else TyllusInterruptOthers = 1
		    print ("|cfcc3300fTyllusInterrupt|r: Self report for Others' interrupt is |cf00cc00fON|r");
		end
	else
	print ("|cfcc3300fTyllusInterrupt|r |cf0ffff00Help|r:");
	print ("|cf0ffff00/tint status|r >> Current setup of interrupt announces");
    print ("|cf0ffff00/tint say|r >> to turn |cf00cc00fon|r or |cfcc3300foff|r  the interrupt announces to SAY channel");
	print ("|cf0ffff00/tint name|r >> to turn |cf00cc00fon|r or |cfcc3300foff|r to announce the name of the interrupted spell");
	print ("|cf0ffff00/tint others|r >> to turn |cf00cc00fon|r or |cfcc3300foff|r to report Others' interrupt to yourself");
	end
end
SlashCmdList["TINT"] = handler;